"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigCatClientConfiguration_1 = require("./ConfigCatClientConfiguration");
var ProjectConfigService_1 = require("./ProjectConfigService");
var AutoPollConfigService = /** @class */ (function (_super) {
    __extends(AutoPollConfigService, _super);
    function AutoPollConfigService(configFetcher, cache, autoPollConfig) {
        var _this = _super.call(this, configFetcher, cache, autoPollConfig) || this;
        if (!autoPollConfig) {
            throw new Error("Invalid 'autoPollConfig' value");
        }
        autoPollConfig.validate();
        _this.timer = setInterval(function () { return _this.refreshConfig(); }, autoPollConfig.pollIntervalSeconds * 1000);
        _this.maxInitWaitExpire = new Date(new Date().getTime() + autoPollConfig.maxInitWaitTimeSeconds * 1000);
        _this.configChanged = autoPollConfig.configChanged;
        return _this;
    }
    AutoPollConfigService.prototype.getConfig = function (callback) {
        var p = this.cache.Get();
        if (!p && new Date().getTime() < this.maxInitWaitExpire.getTime()) {
            this.refreshLogic(callback);
        }
        else {
            callback(p);
        }
    };
    AutoPollConfigService.prototype.refreshConfig = function (callback) {
        this.refreshLogic(callback);
    };
    AutoPollConfigService.prototype.refreshLogic = function (callback) {
        var _this = this;
        var p = this.cache.Get();
        this.refreshLogicBase(p, function (newConfig) {
            if (callback) {
                callback(newConfig);
            }
            if (!p || p.HttpETag !== newConfig.HttpETag) {
                _this.configChanged.emit(ConfigCatClientConfiguration_1.AutoPollConfiguration.CONFIG_CHANGED_EVENT);
            }
        });
    };
    AutoPollConfigService.ON_CHANGED_EVENT = "AutoPollConfigService_OnChanged";
    return AutoPollConfigService;
}(ProjectConfigService_1.ConfigServiceBase));
exports.AutoPollConfigService = AutoPollConfigService;
