/// <reference types="node" />
import * as EventEmitter from "events";
export declare abstract class ConfigurationBase {
    constructor();
    protected validate(): void;
    getUrl(apiKey: string): string;
}
export declare class AutoPollConfiguration extends ConfigurationBase {
    pollIntervalSeconds: number;
    maxInitWaitTimeSeconds: number;
    configChanged: EventEmitter;
    static readonly CONFIG_CHANGED_EVENT: string;
    constructor();
    validate(): void;
}
export declare class ManualPollConfiguration extends ConfigurationBase {
    constructor();
    validate(): void;
}
export declare class LazyLoadConfiguration extends ConfigurationBase {
    cacheTimeToLiveSeconds: number;
    constructor();
    validate(): void;
}
