"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var EventEmitter = require("events");
var ConfigurationBase = /** @class */ (function () {
    function ConfigurationBase() {
    }
    ConfigurationBase.prototype.validate = function () { };
    ConfigurationBase.prototype.getUrl = function (apiKey) {
        if (apiKey) {
            return "https://cdn.configcat.com/configuration-files/" + apiKey + "/config_v2.json";
        }
        throw new Error("Invalid project secret");
    };
    return ConfigurationBase;
}());
exports.ConfigurationBase = ConfigurationBase;
var AutoPollConfiguration = /** @class */ (function (_super) {
    __extends(AutoPollConfiguration, _super);
    function AutoPollConfiguration() {
        var _this = _super.call(this) || this;
        _this.maxInitWaitTimeSeconds = 5;
        _this.pollIntervalSeconds = 60;
        _this.configChanged = new EventEmitter();
        return _this;
    }
    AutoPollConfiguration.prototype.validate = function () {
        _super.prototype.validate.call(this);
        if (!this.maxInitWaitTimeSeconds || this.maxInitWaitTimeSeconds < 1) {
            throw new Error("Invalid 'maxInitWaitTimeSeconds' value");
        }
        if (!this.pollIntervalSeconds || this.pollIntervalSeconds < 1) {
            throw new Error("Invalid 'pollIntervalSeconds' value");
        }
    };
    AutoPollConfiguration.CONFIG_CHANGED_EVENT = "AutoPoll_EventChanged";
    return AutoPollConfiguration;
}(ConfigurationBase));
exports.AutoPollConfiguration = AutoPollConfiguration;
var ManualPollConfiguration = /** @class */ (function (_super) {
    __extends(ManualPollConfiguration, _super);
    function ManualPollConfiguration() {
        return _super.call(this) || this;
    }
    ManualPollConfiguration.prototype.validate = function () {
        _super.prototype.validate.call(this);
    };
    return ManualPollConfiguration;
}(ConfigurationBase));
exports.ManualPollConfiguration = ManualPollConfiguration;
var LazyLoadConfiguration = /** @class */ (function (_super) {
    __extends(LazyLoadConfiguration, _super);
    function LazyLoadConfiguration() {
        var _this = _super.call(this) || this;
        _this.cacheTimeToLiveSeconds = 60;
        return _this;
    }
    LazyLoadConfiguration.prototype.validate = function () {
        _super.prototype.validate.call(this);
        if (!this.cacheTimeToLiveSeconds || this.cacheTimeToLiveSeconds < 1) {
            throw new Error("Invalid 'cacheTimeToLiveSeconds' value. Value must be greater than zero.");
        }
    };
    return LazyLoadConfiguration;
}(ConfigurationBase));
exports.LazyLoadConfiguration = LazyLoadConfiguration;
