import { IConfigFetcher } from "./ConfigFetcher";
import { AutoPollConfiguration, ManualPollConfiguration, LazyLoadConfiguration } from "./ConfigCatClientConfiguration";
import { ICache } from "./Cache";
import { User, IRolloutEvaluator } from "./RolloutEvaluator";
export declare const CONFIG_CHANGE_EVENT_NAME: string;
/** Client for ConfigCat platform */
export interface IConfigCatClient {
    /** Return a value of the key (Key for programs) */
    getValue(key: string, defaultValue: any, user: User, callback: (value: any) => void): void;
    /** Refresh the configuration */
    forceRefresh(callback: () => void): void;
}
export declare class ConfigCatClientImpl implements IConfigCatClient {
    private apiKey;
    private configService;
    private evaluator;
    constructor(apiKey: string, configuration?: AutoPollConfiguration | ManualPollConfiguration | LazyLoadConfiguration, configFetcher?: IConfigFetcher, cache?: ICache, evaluator?: IRolloutEvaluator);
    getValue(key: string, defaultValue: any, user: User, callback: (value: any) => void): void;
    forceRefresh(callback: () => void): void;
}
