"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ProjectConfigService_1 = require("./ProjectConfigService");
var HttpConfigFetcher = /** @class */ (function () {
    function HttpConfigFetcher(url, productVersion) {
        this.url = url;
        this.productVersion = productVersion;
    }
    HttpConfigFetcher.prototype.fetchLogic = function (lastProjectConfig, callback) {
        var httpRequest = new XMLHttpRequest();
        httpRequest.onreadystatechange = function () {
            if (httpRequest.readyState == 4) {
                var etag = httpRequest.getResponseHeader("ETag");
                if (httpRequest.status === 200) {
                    callback(new ProjectConfigService_1.ProjectConfig(new Date().getTime(), httpRequest.responseText, etag));
                }
                else if (httpRequest.status === 304) {
                    callback(new ProjectConfigService_1.ProjectConfig(new Date().getTime(), lastProjectConfig.JSONConfig, etag));
                }
                else {
                    console.log("ConfigCat HTTPRequest error: " + httpRequest.statusText);
                    callback(lastProjectConfig);
                }
            }
        };
        httpRequest.open("GET", this.url, true);
        httpRequest.setRequestHeader("X-ConfigCat-UserAgent", "ConfigCat-JS/" + this.productVersion);
        httpRequest.setRequestHeader("If-None-Match", lastProjectConfig ? lastProjectConfig.HttpETag : null);
        httpRequest.send(null);
    };
    return HttpConfigFetcher;
}());
exports.HttpConfigFetcher = HttpConfigFetcher;
