import IConfigFetcher from "./ConfigFetcher";
import ICache from "./Cache";
import { ConfigurationBase } from "./ConfigCatClientConfiguration";
export declare class ProjectConfig {
    /** Entity identifier */
    HttpETag: string;
    /** ConfigCat config content */
    JSONConfig: string;
    /** Timestamp in milliseconds */
    Timestamp: number;
    constructor(timeStamp: number, jsonConfig: string, httpETag: string);
}
export interface IConfigService {
    getConfig(callback: (value: ProjectConfig) => void): void;
    refreshConfig(callback?: (value: ProjectConfig) => void): void;
}
export declare abstract class ConfigServiceBase {
    protected configFetcher: IConfigFetcher;
    protected cache: ICache;
    constructor(configFetcher: IConfigFetcher, cache: ICache, baseConfig: ConfigurationBase);
    protected refreshLogicBase(lastProjectConfig: ProjectConfig, callback: (value: ProjectConfig) => void): void;
}
