"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ProjectConfig = /** @class */ (function () {
    function ProjectConfig(timeStamp, jsonConfig, httpETag) {
        this.Timestamp = timeStamp;
        this.JSONConfig = jsonConfig;
        this.HttpETag = httpETag;
    }
    return ProjectConfig;
}());
exports.ProjectConfig = ProjectConfig;
var ConfigServiceBase = /** @class */ (function () {
    function ConfigServiceBase(configFetcher, cache, baseConfig) {
        if (!configFetcher) {
            throw new Error("Invalid 'configFetcher' value");
        }
        if (!cache) {
            throw new Error("Invalid 'cache' value");
        }
        if (!baseConfig) {
            throw new Error("Invalid 'baseConfig' value");
        }
        this.configFetcher = configFetcher;
        this.cache = cache;
    }
    ConfigServiceBase.prototype.refreshLogicBase = function (lastProjectConfig, callback) {
        var _this = this;
        this.configFetcher.fetchLogic(lastProjectConfig, function (newConfig) {
            if (newConfig) {
                _this.cache.Set(newConfig);
                callback(newConfig);
            }
        });
    };
    return ConfigServiceBase;
}());
exports.ConfigServiceBase = ConfigServiceBase;
