/// <reference types="node" />
import { IConfigCatClient } from "./ConfigCatClientImpl";
import { EventEmitter } from "events";
/** Create an instance of ConfigCatClient and setup AutoPool mode with default settings */
export declare function createClient(apiKey: string): IConfigCatClient;
/**
 * Create an instance of ConfigCatClient and setup AutoPoll mode
 * @param {string} apiKey - ApiKey to access your configuration.
 * @param config - Configuration for autoPoll mode
 */
export declare function createClientWithAutoPoll(apiKey: string, config?: IConfigurationOptions): IConfigCatClient;
/**
 * Create an instance of ConfigCatClient and setup ManulaPoll mode
 * @param {string} apiKey - ApiKey to access your configuration.
 * @param config - Configuration for manualPoll mode
 */
export declare function createClientWithManualPoll(apiKey: string, config?: IConfigurationOptions): IConfigCatClient;
/**
 * Create an instance of ConfigCatClient and setup LazyLoad mode
 * @param {string} apiKey - ApiKey to access your configuration.
 * @param config - Configuration for lazyLoad mode
 */
export declare function createClientWithLazyLoad(apiKey: string, config?: IConfigurationOptions): IConfigCatClient;
export interface IConfigurationOptions {
    pollIntervalSeconds?: number;
    maxInitWaitTimeSeconds?: number;
    configChanged?: EventEmitter;
    cacheTimeToLiveSeconds?: number;
}
export declare const CONFIG_CHANGED_EVENT: string;
